使用这些去重加密工具来备份你的数据
================================================================================

无论是体积还是价值，数据都在不断增长。快速而可靠地备份和恢复数据正变得越来越重要。社会已经适应了技术的广泛使用，并懂得了如何依靠电脑和移动设备，但很少有人能够面对丢失重要数据的现实。在遭受数据损失的公司中，30% 的公司将在一年内损失一半市值，70% 的公司将在五年内停止交易。这更加凸显了数据的价值。

随着数据在体积上的增长，提高存储利用率尤为重要。从计算机的角度说，数据去重是一种特别的数据压缩技术，因为它可以消除重复数据的拷贝，所以这个技术可以提高存储利用率。

数据并不仅仅只有其创造者感兴趣。政府、竞争者、犯罪分子、偷窥者可能都热衷于获取你的数据。他们或许想偷取你的数据，从你那里进行敲诈，或看你正在做什么。因此，对于保护你的数据，加密是非常必要的。

所以，解决方法是我们需要一个可以去重的加密备份软件。

对于所有的用户而言，做文件备份是一件非常必要的事，至今为止许多用户还没有采取足够的措施来保护他们的数据。一台电脑不论是工作在一个合作的环境中，还是供私人使用，机器的硬盘可能在没有任何警告的情况下挂掉。另外，有些数据丢失可能是人为的错误所引发的。如果没有做经常性的备份，数据也可能不可避免地丢失，即使请了专业的数据恢复公司来帮忙。

这篇文章将对 6 个去重加密备份工具进行简要的介绍。

### Attic ###

Attic 是一个可用于去重、加密，验证完整性的压缩备份程序，它是用 Python 写的。Attic 的主要目标是提供一个高效且安全的方式来备份数据。Attic 使用的数据去重技术使得它适用于每日备份，因为只需存储改变的数据。

其特点有: 

- 易用
- 可高效利用存储空间，通过检查冗余的数据，对可变块大小的去重可以减少存储所用的空间
- 可选的数据加密，使用 256 位的 AES 加密算法。数据的完整性和可靠性使用 HMAC-SHA256 来校验
- 使用 SDSH 来进行离线备份
- 备份可作为文件系统来挂载

网站: [attic-backup.org][1]


### Borg ###

Borg 是 Attic 的一个分支。它是一个安全的开源备份程序，被设计用来高效地存储那些新的或修改过的数据。

Borg 的主要目标是提供一个高效、安全的方式来存储数据。Borg 使用的数据去重技术使得它适用于每日备份，因为只需存储改变的数据。认证加密使得它适用于存储在不完全可信的位置。

Borg 由 Python 写成。Borg 于 2015 年 5 月被创造出来，是为了解决让新的代码或重大的改变带入 Attic 的困难。

其特点包括:

- 易用
- 可高效利用存储空间，通过检查冗余的数据，对可变块大小的去重被用来减少存储所用的空间
- 可选的数据加密，使用 256 位的 AES 加密算法。数据的完整性和可靠性使用 HMAC-SHA256 来校验
- 使用 SDSH 来进行离线备份
- 备份可作为文件系统来挂载

Borg 与 Attic 不兼容。

网站: [borgbackup.github.io/borgbackup][2]

### Obnam ###

Obnam (OBligatory NAMe) 是一个易用、安全的基于 Python 的备份程序。备份可被存储在本地硬盘或通过 SSH SFTP 协议存储到网上。若使用了备份服务器，它并不需要任何特殊的软件，只需要使用 SSH 即可。

Obnam 通过将数据分成数据块，并单独存储它们来达到去重的目的，每次通过增量备份来生成备份，每次备份的生成就像是一次新的快照，但事实上是真正的增量备份。Obnam 由 Lars Wirzenius 开发。

其特点有:

- 易用
- 快照备份
- 数据去重，跨文件，然后生成备份
- 可使用 GnuPG 来加密备份
- 向一个单独的仓库中备份多个客户端的数据
- 备份检查点 (创建一个保存点，以每 100MB 或其他容量)
- 包含多个选项来调整性能，包括调整  lru-size 或 upload-queue-size
- 支持 MD5 校验算法来识别重复的数据块
- 通过 SFTP 将备份存储到一个服务器上
- 同时支持 push(即在客户端上运行) 和 pull(即在服务器上运行)

网站: [obnam.org][3]

### Duplicity ###

Duplicity 以 tar 文件格式增量备份文件和目录，并使用 GnuPG 来进行加密，同时将它们上传到远程(或本地)的文件服务器上。它可以使用 ssh/scp、本地文件获取、rsync、 ftp 和 Amazon S3 等来传递数据。

因为 duplicity 使用了 librsync， 增量存档可以高效地利用存储空间，且只记录自从上次备份依赖改变的那部分文件。由于该软件使用 GnuPG 来加密或对这些归档文件进行进行签名，这使得它们免于服务器的监视或修改。

当前 duplicity 支持备份删除的文件，全部的 unix 权限，目录，符号链接， fifo 等。

duplicity 软件包还包含有 rdiffdir 工具。 Rdiffdir 是 librsync 的 rdiff 针对目录的扩展。它可以用来生成对目录的签名和差异，对普通文件也有效。

其特点有:

- 使用简单
- 对归档进行加密和签名(使用 GnuPG)
- 高效使用带宽和存储空间，使用 rsync 的算法
- 标准的文件格式
- 可选择多种远程协议
    - 本地存储
    - scp/ssh
    - ftp
    - rsync
    - HSI
    - WebDAV
    - Amazon S3

网站: [duplicity.nongnu.org][4]

### ZBackup ###

ZBackup 是一个通用的全局去重备份工具。

其特点包括:

- 对存储数据并行进行 LZMA 或 LZO 压缩，在一个仓库中，你还可以混合使用 LZMA 和 LZO
- 内置对存储数据的 AES 加密
- 能够删除旧的备份数据
- 可以使用 64 位的滚动哈希算法，使得文件冲突的数量几乎为零
- 仓库中存储的文件是不可修改的，已备份的文件不会被修改。
- 用 C++ 写成，只需少量的库文件依赖
- 在生成环境中可以安全使用
- 可以在不同仓库中进行数据交换而不必再进行压缩
- 使用 64 位改进型 Rabin-Karp 滚动哈希算法

网站: [zbackup.org][5]


### bup ###

bup 是一个用 Python 写的备份程序，其名称是 "backup" 的缩写。基于 git packfile 文件格式， bup 提供了一个高效的方式来备份一个系统，提供快速的增量备份和全局去重(在文件中或文件里，甚至包括虚拟机镜像)。

bup 在 LGPL 版本 2 协议下发行。

其特点包括:

- 全局去重 (在文件之间或文件内部，甚至包括虚拟机镜像)
- 使用一个滚动的校验和算法(类似于 rsync) 来将大文件分为多个数据块
- 使用来自 git 的 packfile 文件格式
- 直接写入 packfile 文件，以此提供快速的增量备份
- 可以使用 "par2" 冗余来恢复冲突的备份
- 可以作为一个 FUSE 文件系统来挂载你的 bup 仓库

网站: [bup.github.io][6]

--------------------------------------------------------------------------------

via: http://www.linuxlinks.com/article/20150628060000607/BackupTools.html

译者：[FSSlc](https://github.com/FSSlc)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](https://linux.cn/) 荣誉推出

[1]:https://attic-backup.org/
[2]:https://borgbackup.github.io/borgbackup/
[3]:http://obnam.org/
[4]:http://duplicity.nongnu.org/
[5]:http://zbackup.org/
[6]:https://bup.github.io/