5 个新的 OpenStack 使用指南
============================================================

 ![OpenStack tutorials](https://opensource.com/sites/default/files/styles/image-full-size/public/images/education/rh_003588_01_rd3os.combacktoschoolserieshe_rh_051x_0.png?itok=Tm2UcSXw "OpenStack tutorials") 

图片提供：opensource.com

随着越来越多的组织寻求构建和管理自己的开源云，所以拥有 OpenStack 经验仍然被视为技术界中最需要的技能。但是 OpenStack 是一个巨大的知识领域，包含了十几个正在积极开发的单独项目。仅仅使你的技能跟上它的最新发展就是一个挑战。

好消息是现在有很多资源可以让你跟上这个发展速度。除了其[官方项目文档][9]，各种培训和认证程序、纸质的指南、以及其他资源之外，还有大量的由 OpenStack 社区成员编写并发布在各种博客和线上出版物上的教程和指南。

在 Opensource.com，我们每个月都会收集这些社区资源中最好的资源，并将它们放到一个集锦中。这是我们上个月的内容。

* 这次排第一位的是 Julie Pichon 对 [Mistral 在 TripleO 中的使用][1]的一个快速介绍。Mistral 是一个工作流服务，允许你设置一个多步过程自动化和异步协调操作。在该快速指南中学习 Mistral 的基础知识、它如何工作，以及如何在 TripleO 中使用它。

* 想要使用 OpenStack 自己的一套工具来深入了解 TripleO 管理 OpenStack 部署么？你会想看看这[一组为使用 TripleO 设置 OpenStack 的人士写的简洁提示][2]。这是一个正在进行中的工作，所以如果你还想包含什么，欢迎随时贡献。

* 使用 TripleO 设置独立的 Ceph 部署时，不要错过这个[快速指南][3]，这是我们的 TripleO 指南的第三篇。它所需要的只是一个简短的 YAML 文件和一个简单的命令。

* 接下来，如果你是一个 OpenStack 贡献者，你可能会熟悉 [Grafana 面板][4]，它显示了 OpenStack 持续集成基础设施的各种指标。有没有想过这个服务如何工作，或想创建一个新的指标到面板上？学习[如何创建][5]你自己的本地面板的副本，你可以测试试试，并作出自己的修改。

* 有没有想过 OpenStack 云上的网络底层到底在如何运作的？OpenStack 经常使用 [Open vSwitch][6] 用于 Neutron 和 Nova 的网络服务；在[这个演练][7]中学习设置的基础。

* * *

这次就是这样了。和往常一样，请查看我们完整的 [OpenStack 教程][10]，它汇集了过去三年发布的数百个单独的指南。

--------------------------------------------------------------------------------

作者简介：

Jason Baker - Jason 热衷于使用技术使世界更加开放，从软件开发到阳光政府行动。Linux 桌面爱好者、地图/地理空间爱好者、树莓派工匠、数据分析和可视化极客、偶尔的码农、云本土主义者。在 Twitter 上关注他。

--------------------------------------------------------------------------------

via: https://opensource.com/article/17/1/openstack-tutorials

作者：[Jason Baker][a]
译者：[geekpi](https://github.com/geekpi)
校对：[jasminepeng](https://github.com/jasminepeng)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/jason-baker
[1]:http://www.jpichon.net/blog/2016/12/quick-introduction-mistral-tripleo/
[2]:http://www.anstack.com/blog/2016/12/16/printing-tripleo-cheat-sheet.html
[3]:http://giuliofidente.com/2016/12/tripleo-to-deploy-ceph-standlone.html
[4]:http://grafana.openstack.org/
[5]:http://blog.cafarelli.fr/2016/12/local-testing-of-openstack-grafana-dashboard-changes/
[6]:http://openvswitch.org/
[7]:http://superuser.openstack.org/articles/openvswitch-openstack-sdn/
[8]:https://opensource.com/article/17/1/openstack-tutorials?rate=q5H-KT2pm4NLExRhlHc0ru2dyjLkTSA45wim_2KtIec
[9]:http://docs.openstack.org/
[10]:https://opensource.com/resources/openstack-tutorials
[11]:https://opensource.com/user/19894/feed
[12]:https://opensource.com/users/jason-baker
