印度的社区如何支持隐私和软件自由
============================================================

 ![How communities in India support privacy and software freedom](https://opensource.com/sites/default/files/styles/image-full-size/public/images/life/people_remote_teams_world.png?itok=wI-GW8zX "How communities in India support privacy and software freedom") 

图片提供： opensource.com

印度的自由和开源社区，特别是 Mozilla 和 Wikimedia 社区，它们正在引领两个独特的全球性活动，以提高隐私保护及支持自由软件。

[1 月份的隐私月][3]是由印度 Mozilla 社区领导，通过在线和线下活动向群众教育网络隐私。而[ 2 月份的自由月][4]是由[互联网与社会中心][5]领导，教育内容创作者如博主和摄影师就如何在[开放许可证][6]下捐赠内容。

### 1 月隐私月

从[去年开始][7]的 Mozilla “1 月隐私月”用来帮助庆祝年度[数据隐私日（Data Privacy Day）][8]。在 2016 年，该活动举办了几场涉及到[全球 10 个国家 14,339,443 人][9]的线下和线上活动。其中一个核心组织者，[Ankit Gadgil][10] 这样说到：“每天分享一个隐私提示，持续一个月就能分享 31 天。”今年，我们共有三个重点领域，首先是我们让这个运动更加开放和全球化。巴西、意大利、捷克共和国的 Mozilla 社区今年正在积极参与，所有必要的文档都是本地化的，所以我们可以针对更多的用户。其次，我们在线下活动中教导用户推广 Firefox 以及 Mozilla 的其他产品，以便用户可以亲身体验使用这些工具来帮助保护他们的隐私。第三点，我们鼓励大家参加线下活动并把他们的学习写到博客里面去，例如，最近在印度古吉拉特邦的一个节目中，他们使用 Mozilla 产品来教授隐私方面的知识。”

今年的活动继续有线下和线上活动。关注 #PrivacyAware 参加。

#### 安全提示

像 Firefox 这样的 Mozilla 产品具有安全性设置-有[内置的][11]还有对残疾人完全[可用][12]的附件库-这有助于保护用户的隐私和安全性，这些都是协同构建的并且是开源的。

[Chrome][14] 和[ Opera][15] 中的 [HTTPS Everywhere][13] 插件可用于加密用户通信，使外部网站无法查看用户信息。该项目由 [Tor Project][16] 以及[电子前沿基金会][17]合作建成。

### 2 月自由月

[2 月自由月][18]是一个网络活动，旨在教育内容创作者关于[自由内容][19]，并向他们展示如何在自由许可证下作出贡献。

** 参加规则：**

* 你在二月份制作或出版的作品必须获得[自由许可证][1]许可。
* 内容类型包括博客文章、其他文字和图像。

多媒体，基于文本的内容，艺术和设计等创意作品可以通过多个[知识共享许可证][20]（CC）进行许可，其他类型的文档可以根据 [GNU 免费文档许可][21]（GFDL）许可。Wikipedia 上可以找到很好的例子，其内容根据 CC 和 GFDL 许可证获得许可，允许人们使用、分享、混合和分发衍生用于商业上和非商业性的作品。此外，还有允许开发人员共享他们的软件和软件相关文档的[自由软件许可证][22]。

--------------------------------------------------------------------------------

作者简介：

Subhashish Panigrahi（@shhapa）是 Mozilla 参与团队的亚洲社区催化师，并在 Wikimedia 基金会印度计划的早期扮演了互联网及社会知识获取中心项目官的角色，另外他是一名印度教育工作者，

--------------------------------------------------------------------------------

via: https://opensource.com/article/17/1/how-communities-india-support-privacy-software-freedom

作者：[Subhashish Panigrahi][a]
译者：[geekpi](https://github.com/geekpi)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/psubhashish
[1]:https://en.wikipedia.org/wiki/Free_license#Classification_and_licenses
[2]:https://opensource.com/article/17/1/how-communities-india-support-privacy-software-freedom?rate=WhGQOnXdk0m1Yq63nNe0wTVBP-75ALKLlrssFW2lCLk
[3]:https://wiki.mozilla.org/India/task_force/Policy_and_Advocacy/January_Privacy_Month_Campaign
[4]:http://www.freedominfeb.org/
[5]:http://cis-india.org/
[6]:https://opensource.com/education/16/8/3-copyright-tips-students-and-educators
[7]:https://reps.mozilla.org/e/privacy-month-campaign/
[8]:https://en.wikipedia.org/wiki/Data_Privacy_Day
[9]:http://blog.mozillaindia.org/1611
[10]:https://reps.mozilla.org/u/ankitgadgil
[11]:https://support.mozilla.org/en-US/products/firefox/protect-your-privacy
[12]:https://support.mozilla.org/en-US/kb/advanced-panel-settings-in-firefox
[13]:https://www.eff.org/files/https-everywhere-latest.xpi
[14]:https://chrome.google.com/webstore/detail/gcbommkclmclpchllfjekcdonpmejbdp
[15]:https://addons.opera.com/extensions/details/https-everywhere/
[16]:https://www.torproject.org/
[17]:https://eff.org/
[18]:http://www.freedominfeb.org/
[19]:https://en.wikipedia.org/wiki/Free_content
[20]:https://creativecommons.org/licenses/
[21]:https://en.wikipedia.org/wiki/GNU_Free_Documentation_License
[22]:https://www.gnu.org/licenses/license-list.en.html#GPLCompatibleLicenses
[23]:https://opensource.com/user/21177/feed
[24]:https://opensource.com/users/psubhashish
