为什么可以在任何地方工作的开发者们要聚集到世界上最昂贵的城市？
============================================================

![](https://tctechcrunch2011.files.wordpress.com/2017/04/img_20170401_1835042.jpg?w=977) 

政治家和经济学家都在[哀嚎][10]某几个阿尔法地区——旧金山、洛杉矶、纽约、波士顿、多伦多、伦敦、巴黎——在吸引了所有最好的工作的同时变得令人却步的昂贵，降低了经济流动性而增大了贫富差异。为什么那些最好的工作不能搬到其它地区呢？

当然，很多工作都不能搬走。工作在纽约或者伦敦（当然，在英国脱欧毁灭伦敦的银行体系之前）普通的金融从业人员如果告诉他们的老板他们想要以后在清迈工作，将会在办公室里受到嘲笑而且不再受欢迎。

但是这对（大部分）软件领域不适用。大部分 web/app 开发者如果这样要求的话可能会被拒绝；但是它们至少不会被嘲笑或者被炒。优秀开发者往往供不应求，而且我们处在 Skype 和 Slack 的时代，软件开发完全可以不依赖物质世界的交互。

（这一切对作家来说更加正确，真的；事实上我是在波纳佩发表的这篇文章。但是作家并不像软件开发者一样具有足够的影响力。）

有些人会告诉你远程协助的团队天生比本地团队效率和生产力低下一些，或者那些“不经意的灵感碰撞”是如此重要以致于每一位员工每天都必须强制到一个地方来人为的制造这样的碰撞。这些人错了，有这种问题的团队只是讨论次数不够多——数量级不过几次、十几次或者几十次，而不是成百上千——也不够专注。

我知道：在 [HappyFunCorp][11] 时，我们广泛的与远程团队工作，而且长期雇佣远程开发者，而结果难以置信的好。我在我旧金山的家中与斯德哥尔摩、圣保罗、上海、布鲁克林、新德里的开发者交流和合作的一天，完全没有任何不寻常。

在这一点上，不管它是不是个好主意，但我有点跑题了。供求关系指出那些拥有足够技能的开发者可以成为被称为“数字流浪者”的人，如果他们愿意的话。但是许多可以做到的人却不愿意。最近，我在雷克雅维克的一栋通过 Airbnb 共享的房子和一伙不断变化的临时远程工作团队度过了一段时间，我按照东海岸的时间来跟上他们的工作，也把早上和周末的时光都花费在探索冰岛了——但是最后几乎所有人都回到了湾区生活。

从经济层面来说，当然，这太疯狂了。搬到东南亚工作光在房租一项上每月就会为我们省下几千美金。 为什么那些可以在哥斯达黎加挣着旧金山的工资，或者在柏林赚着纽约水平薪资的人们，选择不这样做？为什么那些据说冷静固执的工程师在财政方面如此荒谬？

当然这里有社交和文化原因。清迈很不错，但没有大都会博物馆或者蒸汽朋克化装舞会，也没有 15 分钟脚程可以到的 50 家美食餐厅。柏林也很可爱，但没法提供风筝冲浪或者山脉远足和加州气候。当然也无法保证拥有无数和你一样分享同样价值观和母语的人们。

但是我觉得原因除了这些还有很多。我相信相比贫富之间的差异，还有一个更基础的经济分水岭存在。我认为我们在目睹世界上可以实现超凡成就的“极端斯坦（Extremistan）”城市和无法成就伟大但可以工作和赚钱的“平均斯坦（Mediocristan）”城市之间正在生成巨大的裂缝。（这些名词是从伟大的纳西姆·塔勒布那里偷来的）

（LCTT 译者注：[平均斯坦与极端斯坦的概念是美国学者纳西姆·塔勒布首先提出来的。他发现在我们所处的世界上，有些事物表现出相当的平均性，大部分个体都靠近均值，离均值越远则个体数量越稀少，与均值的偏离达到一定程度的个体数量将趋近于零。有些事物则表现出相当的极端性，均值这个概念在这个领域没有太多的意义，剧烈偏离均值的个体大量存在，而且偏离程度大得惊人。他把前者称为平均斯坦，把后者称为极端斯坦。][15]）

艺术行业有着悠久历史的“极端斯坦”城市。这也解释了为什么有抱负的作家纷纷搬到纽约城，而那些已经在国际上大获成功的导演和演员仍然在不断被吸引到洛杉矶，如同飞蛾扑火。现在，这对技术行业同样适用。即使你不曾想试着（帮助）构造一些非凡的事物 —— 如今创业神话如此恢弘，很难想象有工程师完全没有梦想过它 —— _伟大事物发生的地方_正在以美好的前景如梦如幻的吸引着人们。

但是关于这一切有趣的是，理论上讲，它会改变；因为 —— 直到最近 —— 分布式的、分散管理的团队实际上可以获得超凡的成就。 情况对这些团队很不利，因为风投的目光趋于短浅。但是没有任何法律指出独角兽公司只能诞生在加州和某些屈指可数的次级地域上；而且似乎，不管结果好坏，极端斯坦正在扩散。如果这样的扩散最终可以矛盾地导致米申地区的房租变_便宜_那就太棒了！

--------------------------------------------------------------------------------

via: https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/

作者：[Jon Evans][a]
译者：[xiaow6](https://github.com/xiaow6)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://techcrunch.com/author/jon-evans/
[1]:https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/#comments
[2]:https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/#
[3]:http://twitter.com/share?via=techcrunch&amp;url=http://tcrn.ch/2owXJ0C&amp;text=Why%20do%20developers%20who%20could%20work%20anywhere%20flock%20to%20the%20world%E2%80%99s%20most%20expensive%C2%A0cities%3F&amp;hashtags=
[4]:https://www.linkedin.com/shareArticle?mini=true&amp;url=https%3A%2F%2Ftechcrunch.com%2F2017%2F04%2F02%2Fwhy-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities%2F&amp;title=Why%20do%20developers%20who%20could%20work%20anywhere%20flock%20to%20the%20world%E2%80%99s%20most%20expensive%C2%A0cities%3F
[5]:https://plus.google.com/share?url=https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/
[6]:http://www.reddit.com/submit?url=https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/&amp;title=Why%20do%20developers%20who%20could%20work%20anywhere%20flock%20to%20the%20world%E2%80%99s%20most%20expensive%C2%A0cities%3F
[7]:http://www.stumbleupon.com/badge/?url=https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/
[8]:mailto:?subject=Why%20do%20developers%20who%20could%20work%20anywhere%20flock%20to%20the%20world%E2%80%99s%20most%20expensive%C2%A0cities?&amp;body=Article:%20https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/
[9]:https://share.flipboard.com/bookmarklet/popout?v=2&amp;title=Why%20do%20developers%20who%20could%20work%20anywhere%20flock%20to%20the%20world%E2%80%99s%20most%20expensive%C2%A0cities%3F&amp;url=https://techcrunch.com/2017/04/02/why-do-developers-who-could-work-anywhere-flock-to-the-worlds-most-expensive-cities/
[10]:https://mobile.twitter.com/Noahpinion/status/846054187288866
[11]:http://happyfuncorp.com/
[12]:https://twitter.com/rezendi
[13]:https://techcrunch.com/author/jon-evans/
[14]:https://techcrunch.com/2017/04/01/discussing-the-limits-of-artificial-intelligence/
[15]:http://blog.sina.com.cn/s/blog_5ba3d8610100q3b1.html
