4 个 Linux 桌面上的轻量级图像浏览器
============================================================

> 当你需要的不仅仅是一个基本的图像浏览器，而是一个完整的图像编辑器，请查看这些程序。

![4 lightweight image viewers for the Linux desktop](https://opensource.com/sites/default/files/styles/image-full-size/public/images/business/lightbulb-idea-think-yearbook-lead.png?itok=56ovNk8n "4 lightweight image viewers for the Linux desktop")

像大多数人一样，你计算机上可能有些照片和其他图像。而且，像大多数人一样，你可能想要经常查看那些图像和照片。

而启动一个 [GIMP][18] 或者 [Pinta][19] 这样的图片编辑器对于简单的浏览图片来说太笨重了。

另一方面，大多数 Linux 桌面环境中包含的基本图像查看器可能不足以满足你的需要。如果你想要一些更多的功能，但仍然希望它是轻量级的，那么看看这四个 Linux 桌面中的图像查看器，如果还不能满足你的需要，还有额外的选择。

### Feh

[Feh][20] 是我以前在老旧计算机上最喜欢的软件。它简单、朴实、用起来很好。

你可以从命令行启动 Feh：只将其指向图像或者包含图像的文件夹之后就行了。Feh 会快速加载，你可以通过鼠标点击或使用键盘上的向左和向右箭头键滚动图像。不能更简单了。

Feh 可能很轻量级，但它提供了一些选项。例如，你可以控制 Feh 的窗口是否具有边框，设置要查看的图像的最小和最大尺寸，并告诉 Feh 你想要从文件夹中的哪个图像开始浏览。

![Feh](https://opensource.com/sites/default/files/u128651/feh.png "Feh")

*Feh 的使用*

### Ristretto

如果你将 Xfce 作为桌面环境，那么你会熟悉 [Ristretto][21]。它很小、简单、并且非常有用。

怎么简单？你打开包含图像的文件夹，单击左侧的缩略图之一，然后单击窗口顶部的导航键浏览图像。Ristretto 甚至有幻灯片功能。

Ristretto 也可以做更多的事情。你可以使用它来保存你正在浏览的图像的副本，将该图像设置为桌面壁纸，甚至在另一个应用程序中打开它，例如，当你需要修改一下的时候。

![Ristretto](https://opensource.com/sites/default/files/u128651/ristretto.png "Ristretto")

*在 Ristretto 中浏览照片 *

### Mirage

表面上，[Mirage][22]有点平常，没什么特色，但它做着和其他优秀图片浏览器一样的事：打开图像，将它们缩放到窗口的宽度，并且可以使用键盘滚动浏览图像。它甚至可以使用幻灯片。

不过，Mirage 将让需要更多功能的人感到惊喜。除了其核心功能，Mirage 还可以调整图像大小和裁剪图像、截取屏幕截图、重命名图像，甚至生成文件夹中图像的 150 像素宽的缩略图。

如果这还不够，Mirage 还可以显示 [SVG 文件][23]。你甚至可以从[命令行][24]中运行。


![Mirage](https://opensource.com/sites/default/files/u128651/mirage.png "Mirage")

*使用 Mirage*

### Nomacs

[Nomacs][25] 显然是本文中最重量级的图像浏览器。它所呈现的那么多功能让人忽视了它的速度。它快捷而易用。

Nomacs 不仅仅可以显示图像。你还可以查看和编辑图像的[元数据][26]，向图像添加注释，并进行一些基本的编辑，包括裁剪、调整大小、并将图像转换为灰度。Nomacs 甚至可以截图。

一个有趣的功能是你可以在桌面上运行程序的两个实例，并在这些实例之间同步图像。当需要比较两个图像时，[Nomacs 文档][27]中推荐这样做。你甚至可以通过局域网同步图像。我没有尝试通过网络进行同步，如果你做过可以分享下你的经验。


![Nomacs](https://opensource.com/sites/default/files/u128651/nomacs.png "Nomacs")

*Nomacs 中的照片及其元数据*

### 其他一些值得一看的浏览器

如果这四个图像浏览器不符合你的需求，这里还有其他一些你可能感兴趣的。

**[Viewnior][11]** 自称是 “GNU/Linux 中的快速简单的图像查看器”，它很适合这个用途。它的界面干净整洁，Viewnior 甚至可以进行一些基本的图像处理。

如果你喜欢在命令行中使用，那么 **display** 可能是你需要的浏览器。 **[ImageMagick][12]** 和 **[GraphicsMagick][13]** 这两个图像处理软件包都有一个名为 display 的应用程序，这两个版本都有查看图像的基本和高级选项。

**[Geeqie][14]** 是更轻和更快的图像浏览器之一。但是，不要让它的简单误导你。它包含的功能有元数据编辑功能和其它浏览器所缺乏的查看相机 RAW 图像格式的功能。

**[Shotwell][15]** 是 GNOME 桌面的照片管理器。然而它不仅仅能浏览图像，而且 Shotwell 非常快速，并且非常适合显示照片和其他图形。

_在 Linux 桌面中你有最喜欢的一款轻量级图片浏览器么？请在评论区随意分享你的喜欢的浏览器_

（题图：[互联网存档图书图片][17]. 由 Opensource.com 修改。 CC BY-SA 4.0）

--------------------------------------------------------------------------------

作者简介：

我是一名长期使用自由/开源软件的用户，并因为乐趣和收获写各种东西。我不会很严肃。你可以在这些网站上找到我：Twitter、Mastodon、GitHub。

via: https://opensource.com/article/17/7/4-lightweight-image-viewers-linux-desktop

作者：[Scott Nesbitt][a]
译者：[geekpi](https://github.com/geekpi)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/scottnesbitt
[1]:https://opensource.com/resources/what-is-linux?intcmp=70160000000h1jYAAQ&utm_source=intcallout&utm_campaign=linuxcontent
[2]:https://opensource.com/resources/what-are-linux-containers?intcmp=70160000000h1jYAAQ&utm_source=intcallout&utm_campaign=linuxcontent
[3]:https://developers.redhat.com/promotions/linux-cheatsheet/?intcmp=70160000000h1jYAAQ&utm_source=intcallout&utm_campaign=linuxcontent
[4]:https://developers.redhat.com/cheat-sheet/advanced-linux-commands-cheatsheet?intcmp=70160000000h1jYAAQ&utm_source=intcallout&utm_campaign=linuxcontent
[5]:https://opensource.com/tags/linux?intcmp=70160000000h1jYAAQ&utm_source=intcallout&utm_campaign=linuxcontent
[6]:https://opensource.com/file/361216
[7]:https://opensource.com/file/361231
[8]:https://opensource.com/file/361221
[9]:https://opensource.com/file/361226
[10]:https://opensource.com/article/17/7/4-lightweight-image-viewers-linux-desktop?rate=UcKbaJQJAbLScWVu8qm9bqii7JMsIswjfcBHt3aRnEU
[11]:http://siyanpanayotov.com/project/viewnior/
[12]:https://www.imagemagick.org/script/display.php
[13]:http://www.graphicsmagick.org/display.html
[14]:http://geeqie.org/
[15]:https://wiki.gnome.org/Apps/Shotwell
[16]:https://opensource.com/user/14925/feed
[17]:https://www.flickr.com/photos/internetarchivebookimages/14758810172/in/photolist-oubL5m-ocu2ck-odJwF4-oeq1na-odgZbe-odcugD-w7KHtd-owgcWd-oucGPe-oud585-rgBDNf-obLoQH-oePNvs-osVgEq-othPLM-obHcKo-wQR3KN-oumGqG-odnCyR-owgLg3-x2Zeyq-hMMxbq-oeRzu1-oeY49i-odumMM-xH4oJo-odrT31-oduJr8-odX8B3-obKG8S-of1hTN-ovhHWY-ow7Scj-ovfm7B-ouu1Hj-ods7Sg-qwgw5G-oeYz5D-oeXqFZ-orx8d5-hKPN4Q-ouNKch-our8E1-odvGSH-oweGTn-ouJNQQ-ormX8L-od9XZ1-roZJPJ-ot7Wf4
[18]:https://www.gimp.org/
[19]:https://pinta-project.com/pintaproject/pinta/
[20]:https://feh.finalrewind.org/
[21]:https://docs.xfce.org/apps/ristretto/start
[22]:http://mirageiv.sourceforge.net/
[23]:https://en.wikipedia.org/wiki/Scalable_Vector_Graphics
[24]:http://mirageiv.sourceforge.net/docs-advanced.html#cli
[25]:http://nomacs.org/
[26]:https://iptc.org/standards/photo-metadata/photo-metadata/
[27]:http://nomacs.org/synchronization/
[28]:https://opensource.com/users/scottnesbitt
[29]:https://opensource.com/users/scottnesbitt
[30]:https://opensource.com/article/17/7/4-lightweight-image-viewers-linux-desktop#comments
